





          Welcome Blakbook, a demonstration of ClipI/O!
          =============================================

          The screen is divided into 7 sections:

            1) The top line displays the options available.  You can select
               any of these options at any time by either pressing down and
               holding the left mouse button, selection an option, and
               releasing the left button.  Notice that the options Print
               and System have sub-menus which are automatically pulled-
               down.  You can also select any of these options with the
               keyboard by pressing <Alt> and the first letter of the
               option you want.

            2) The upper left section of the screen contains family
               information in a browse-style window.  You can select any
               field in this window by placing the mouse cursor over it and
               clicking the left button.  Notice that when you select
               different families, the information displayed in the other
               three windows changes.  To edit a field, move the mouse
               cursor into the field and double click the left-button, that
               is, press and release the left button twice without moving
               the mouse cursor.

            3) The upper right section of the screen contains family member
               information.  The members of the currently selected family
               are displayed in this section.  Each family can have an
               unlimited number of members.  As with the families, you can
               select any member by moving the cursor and clicking the left
               button.

            4) The section between the family and member windows is mouse
               control strip.  Clicking the left button on any of the
               characters there performs a different function.  For
               example, left-clicking on the T moves you to the top of the
               file, on the solid up-arrow pages up on screen, and on the
               line up-arrow moves the highlight up one line.  The other
               characters perform similar functions except in the opposite
               direction.  Notice that the mouse control strip effects the
               currently selected window.

            5) The lower left section contains the address for the
               currently selected family.  You can click on any of the
               fields in this section to edit them.  Notice that even after
               you activate the address window, you can move from field to
               field within the READ by left-clicking on the desired field.

            6) The lower right section contains notes for the currently
               selected family.  You can activate this window by clicking
               anywhere within it.  The notes are edited using MEMOEDIT().

            7) The bottom line displays messages and relevant help
               information.














          The following are suggestions designed to demonstrate the
          features of ClipI/O through Blakbook (they assume you have a
          mouse and the driver is installed):

            1) You can move from one window to another simply by clicking
               within the desired window.  You can also select fields
               within the window you are activating by clicking on the
               desired field and pausing before you release the left
               button.

            2) Try adding a member to the currently selected family.  Its
               easy.  Just click anywhere in the member window (upper
               right).  Now move the cursor into the menu-bar (top line)
               and click on Insert.

            3) Now delete the member you just added.  First select that
               member by clicking anywhere on it.  Then click on Delete in
               the menu-bar at the top of the screen.  Now click on the Yes
               box.

            4) Now jump to the last family in the database.  First click
               anywhere in the family window.  Now click on the B in the
               section between the upper left and right windows.

            5) Why don't you make a note for this family.  Just click
               anywhere in the Notes window and start typing.

            6) That family's address has changed.  Click on the first field
               in the address window and update the street address.

            7) Now jump straight to the zip code field by clicking on it.

            8) Don't like the colors I selected for you.  Just move the
               mouse cursor onto System in the menu-bar at the top of the
               screen.  Press and hold down the left button, drag the
               highlight down to Colors, and release the button.  Why don't
               you change the frame color.  Again, press and hold down the
               left button, drag the highlight to Frame, and release.  To
               select a color, move the mouse cursor over the color
               combination you want and click.  Try changing other color
               attributes.  When you are done.  Press <Enter> to return to
               the main screen.

          Did you ever imagine that applications written in Clipper could
          be this user-friendly?  Remember, complete mouse support is just
          one of the features of ClipI/O.  Other features include:

            ** Video I/O that's 25% faster than Clipper's @ SAY construct.
               The ability to write to the screen in any color without
               changing the default colors.  The ability to change the
               standard, enhanced, and unselected color attributes without
               affecting the others.













            ** Full keyboard support.  ClipI/O provides functions that
               allow you to stuff ANY KEY into the keyboard buffer.  That
               includes function and alt keys!  And you can stuff keys with
               separate function calls WITHOUT flushing the keyboard
               buffer.  You can also save, restore, and clear the current
               SET KEYs!

            ** You also get the fast, mouse-compatible menus and browsers
               used in Blakbook.  MENUEDIT(), ClipI/O's version of
               DBEDIT(), supports WHILE conditions!  That means you can
               display subsets of a database at INDEX, not FILTER, speeds.
               That's how the members of a family are displayed in
               Blakbook.

            ** Finally, all of the functions in ClipI/O can be called from
               C or Assembler routines!  That means you can write your own,
               fast, efficient UDFs and have access to mouse, video, and
               keyboard I/O.  Without ClipI/O, your UDFs written in C or
               Assembler are restricted to doing little more than
               calculations and returning values.

          If you still aren't convinced that ClipI/O will radically improve
          the quality of you Clipper programs, try ClipI/O out.  A complete
          manual is included in this demo.  To print it out, just type
          "copy clipio.man prn <Enter>" at the DOS prompt.  You can link
          any of the functions into your own Clipper applications.  The
          only difference between this version of ClipI/O and the regular
          one is that your applications will abort after five minutes.

          If you decide or already have decided to purchase ClipI/O, just
          print out the file Readme.Doc.  It contains an order form.





























